using System;
using System.Windows.Forms;
using System.ComponentModel;

namespace MiniLib.Presentation
{
    public class CursorReplacer : IDisposable
    {
        private readonly Cursor _previous;

        public CursorReplacer()
           : this(Cursors.WaitCursor)
        {
        }

        public CursorReplacer(Cursor current)
        {
            _previous = Cursor.Current;
            Cursor.Current = current;
        }

        #region IDisposable Members

        void IDisposable.Dispose()
        {
            Restore();
        }

        #endregion

        public Cursor Previous
        {
            get { return _previous; }
        }

        public void Restore()
        {
            Cursor.Current = _previous;
        }
    }
}
